View Issue Details

IDProjectCategoryView StatusLast Update
0010654LazarusWidgetsetpublic2011-12-01 11:23
ReporterpitwalkerAssigned ToPaul Ishenin 
PrioritynormalSeveritytrivialReproducibilityalways
Status closedResolutionfixed 
Product Version0.9.24Product Build 
Target Version1.0.0Fixed in Version0.9.29 (SVN) 
Summary0010654: runtime error: onShow, onPaint, onActivate, onEnter order error on the form's first appear
DescriptionI cannot create graphical application with visual actions after
form's first appear.
Any action runs in the background.

with my code:
  In Tubo Delphi Explorer the order is:
    Create, Show, PAINT, ACTIVATE, ENTER
  In Lazarus 0.9.24 the order is:
    Create, Show, Enter, Activate, PAINT
Additional Informationprocedure TForm1.FormCreate(Sender: TObject);
begin
  application.MessageBox('onCreate','event',0); //1st, don't show in the taskbar
  firstshow:=true;
  firstpaint:=true;
  firstactivate:=true;
  firstenter:=true;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  If firstshow then begin
    firstshow:=false;
    application.MessageBox('onShow','event',0); //2nd, don't show in the taskbar
  end;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  If firstPaint then begin
    //form appears
    FirstPaint:=False;
    application.MessageBox('onPaint','event',0); //5th, form appear (but not correct at first)
  end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  If firstactivate then begin
    Firstactivate:=False;
    application.MessageBox('onActivate','event',0); //4th, form not visible!
  end;
end;

procedure TForm1.Button1Enter(Sender: TObject);
begin
  IF firstenter then begin
    firstenter:=false;
    application.MessageBox('onEnter','event',0); //3rd, appear in the taskbar
  end;
end;


procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  application.MessageBox('onClose','event',0); //6th
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  application.MessageBox('onDestroy','event',0); //message don't appear
end;
TagsNo tags attached.
Fixed in Revision25274
LazTarget1.0
WidgetsetWin32/Win64
Attached Files

Activities

2008-01-18 14:31

 

eventorderbug.zip (13,149 bytes)

Paul Ishenin

2009-09-12 11:47

manager   ~0030654

Lazarus 0.9.29 order is:
Create, Show, Paint, Enter, Activate

Is it ok for you?

Paul Ishenin

2010-05-09 15:35

manager   ~0037395

Now event order is the same as in delphi. Please test and close if ok.

Issue History

Date Modified Username Field Change
2008-01-18 14:31 pitwalker New Issue
2008-01-18 14:31 pitwalker File Added: eventorderbug.zip
2008-01-18 14:31 pitwalker Widgetset => Win32
2008-01-18 15:34 Paul Ishenin LazTarget => 1.0
2008-01-18 15:34 Paul Ishenin Status new => acknowledged
2008-04-24 09:57 Vincent Snijders Target Version => 1.0.0
2009-09-12 11:47 Paul Ishenin Note Added: 0030654
2010-05-09 15:35 Paul Ishenin Fixed in Revision => 25274
2010-05-09 15:35 Paul Ishenin Status acknowledged => resolved
2010-05-09 15:35 Paul Ishenin Fixed in Version => 0.9.29 (SVN)
2010-05-09 15:35 Paul Ishenin Resolution open => fixed
2010-05-09 15:35 Paul Ishenin Assigned To => Paul Ishenin
2010-05-09 15:35 Paul Ishenin Note Added: 0037395
2011-12-01 11:23 Marc Weustink Status resolved => closed